"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@babel/core");
function mergePropTypes(objectExpr, propTypes) {
    var properties = objectExpr.properties;
    var existingProps = {};
    // Extract existing props so that we don't duplicate
    properties.forEach(function (property) {
        if (core_1.types.isObjectProperty(property) && core_1.types.isIdentifier(property.key)) {
            existingProps[property.key.name] = true;
        }
    });
    // Add to the beginning of the array so existing/custom prop types aren't overwritten
    propTypes.forEach(function (propType) {
        if (core_1.types.isIdentifier(propType.key) && !existingProps[propType.key.name]) {
            properties.unshift(propType);
        }
    });
}
exports.default = mergePropTypes;
