import { types as t, traverse } from '@babel/core';
export declare type Path<N> = traverse.NodePath<N>;
export declare type TypePropertyMap = {
    [key: string]: t.TSPropertySignature[];
};
export declare type PropType = t.MemberExpression | t.CallExpression | t.Identifier;
export declare type ConvertState = {
    airbnbPropTypes: {
        count: number;
        forbidImport: string;
        hasImport: boolean;
        namedImports: string[];
    };
    componentTypes: TypePropertyMap;
    filePath: string;
    options: PluginOptions;
    propTypes: {
        count: number;
        defaultImport: string;
        hasImport: boolean;
    };
    reactImportedName: string;
};
export declare type PluginOptions = {
    customPropTypeSuffixes?: string[];
    forbidExtraProps?: boolean;
};
